syms a x
p = @(x) x^4 + x + 1;
Primitive(p(x), 2)
fs = double(2^(feval(symengine, 'degree', p(x))))
for i = 1:fs-1
    field(i) = Powmod(a, i, p(a), a, 2);
end
field(fs) = 0;
field
t = 2;
g = 1;
for j = 1:2*t
    g = g*(x-a^j);
end
g
g = rscoeff(g, x, p(a), a)
sortpoly(g, x)
class(ans)
sym(sortpoly(g, x))
class(ans)
c = rscoeff((a^10*x^9+a^3*x^5+a^2*x^3)*g, x, p(a), a)
sortpoly(c, x)
cbin = binword(c, double(feval(symengine, 'degree', ...
p(x))), p(a), a, fs-2)
rbin = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, ...
1, 0, 1, 1, 0, 0, 0, 0, 1, 1, 0, 1, 1, 0, 1, 1, 1, ...
0, 1, 0, 0, 0, 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 1, 1, ...
0, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0];
pcoeff = bincoeff(double(feval(symengine, 'degree', ...
p(x))), rbin)
r = 0;
for i = 1:numel(pcoeff)
    r = r + pcoeff(i)*x^(i-1);
end
r
r = rscoeff(r, x, p(a), a)
r = @(x) subs(r, 'x', x);
sortpoly(r(x), x)
for i = 1:2*t
    syn(i) = ftable(Rem(r(a^i), p(a), a, 2), field);
end
syn
syms z
S = 0;
for j = 0:2*t-1
    S = S + syn(j+1)*z^j;
end
S
S = @(z) subs(S, 'z', z);
sortpoly(S(z), z)
f = z^(2*t)
res = rseuclid(t, f, S(z), z, p(a), a)
R = res(2)
R = @(z) subs(R, 'z', z);
sortpoly(R(z), z)
V = res(3)
V = @(z) subs(V, 'z', z);
sortpoly(V(z), z)
for i = 1:fs-1
    if sym2poly(Rem(V(a^i), p(a), a, 2)) == 0
       pos = feval(symengine, 'degree', a^(fs-1)/ ...
       a^i, a);
       disp([char(a^i) blanks(1) 'is a root of' ...
       blanks(1) sortpoly(V(z), z)])
       fprintf('Error Position is %3.0f \n \n', ...
       double(pos))
    end
end
Vp = feval(symengine, 'expr', feval(symengine, ...
'poly', diff(V(z), z), 'Dom::IntegerMod(2)'))
Vp = @(z) subs(Vp, 'z', z);
sortpoly(Vp(z), z)
e10 = ftable(Rem(R(a^5), p(a), a, 2), field)/ ...
ftable(Rem(Vp(a^5), p(a), a, 2), field);
e11 = ftable(Rem(R(a^4), p(a), a, 2), field)/ ...
ftable(Rem(Vp(a^4), p(a), a, 2), field);
e = e10*x^10 + e11*x^11
e = rscoeff(e, x, p(a), a)
e = @(x) subs(e, 'x', x);
sortpoly(e(x), x)
c = rscoeff(r(x)+e(x), x, p(a), a)
sortpoly(c, x)
for i = 1:2*t
    sync(i) = Rem(subs(c, x, a^i), p(a), a, 2);
end
sync
ebin = binword(e(x), double(feval(symengine, ...
'degree', p(x))), p(a), a, fs-2)
numel(find(ebin == 1))