function res = Primitive(f, p)
   S = symengine;
   v = feval(S, 'indets', f);
   pv = strcat('[', char(v(1)), ']');
   if strcmp(class(p), 'sym') == 1
      pd = strcat('Dom::IntegerMod(', char(p), ')');
   else
      pd = strcat('Dom::IntegerMod(', num2str(p), ')');
   end
   fp = feval(S, 'poly', f, pv, pd);
   if ~feval(S, 'irreducible', fp)
      res = 'FALSE';
   else
      d = feval(S, 'degree', fp);
      n = p^d; 
      pdiv = feval(symengine, 'numlib::primedivisors', n-1);
      res = 'TRUE'; 
      xt = feval(S, 'poly', v(1), pv, pd);
      for i = 1:length(pdiv) 
          e = double((n-1)/pdiv(i));
          if feval(S, 'expr', feval(S, 'powermod', xt, e, fp)) == 1
             res = 'FALSE';
          end
      end
   end

