function res = aesencipher(message, key, St, p, x)
    A = reshape(topoly(message,x), 4, 4);
    Keyin = reshape(topoly(key,x), 4, length(key)/4);
    KS = keysched(Keyin, St, p, x);
    nk = size(Keyin,2);
    nr = nk+6;
    K0 = KS(1:4, 1:4);
    Ai = addrkey(A,K0);
    for i=1:nr-1
        B = bytesub(Ai, St, p, x);
        C = shiftrow(B);
        Dm = mixcolumn(C, p, x);
        Ki = KS(1:4, 4*i+1:4*(i+1));
        Ai = addrkey(Dm,Ki);
    end
    B = bytesub(Ai, St, p, x);
    C = shiftrow(B);
    Ki = KS(1:4, 4*nr+1:4*(nr+1));
    Ai = addrkey(C,Ki);
    [m n] = size(Ai);
    for i = 1:m
        for j = 1:n
            res(i,j) = bin2dec(int2str(sym2poly(Ai(i,j))));
        end
    end
    res = reshape(res, 1, numel(res));