function cres = cidn(n, x)
   S = symengine;
   d =  feval(S, 'numlib::divisors', n);
   p = sym('0');
   for i = 1:numel(d)
       v = sym(strcat(char(x),char(d(i))));
       p = p + feval(S, 'numlib::phi', d(i))*v^(n/d(i));
   end
   for i = 1:n
       var{i} = sym(strcat(char(x),num2str(i)));
   end
   if mod(n, 2) == 1
      p = 1/(2*n)*p + 1/2*var{1}*var{2}^((n-1)/2);
   else
      p = 1/(2*n)*p + 1/4*(var{1}^2*var{2}^((n-2)/2) + var{2}^(n/2));
   end
   cres{1} = p;
   cres{2} = var;
