function r = firstpart(n)
    if n < 0
       r = strcat('Error: Input must be a non-negative integer but received', blanks(1), char(n));
    elseif n == 0 
       r = '[]';
    elseif n == 1
       r = '[1]';
    else
       a = zeros(1, n);
       k = 2;
       a(2) = n;  
       x = a(k-1) + 1;
       y = a(k) - 1;
       k = k - 1;
       while x <= y
          a(k) = x; 
          y = y-x;
          k = k+1;
       end
       a(k) = x+y;
       s = 0;
       j = 0;
       r = '['; 
       for i = 1:numel(a)
           s = s + a(i);
           if s <= n
              j = j + 1;
              r = [r, int2str(a(i)), ', '];
           end
       end
       r(numel(r)-1) = '';
       r(numel(r)) = ']';
    end





