function cres = igraph(n,x)
    S = symengine;
    x = sym(x);
    maxv = n;
    cires = 0;
    for i = 0:floor((n-1)/2)
        os{i+1} = 2*i+1;
    end
    for i = 1:floor(n/2)
        es{i} = 2*i;
    end
    for pnum = 1:double(feval(S, 'combinat::partitions', n))
        if pnum == 1
           part = firstpart(n);
        else
           part = nextpart(part);
        end
        P = zeros(1,n);
        P = partlist(part,P);
        w = 1;
        for k = 1:n
            w = w*(1/(sym(k)^P(k)* feval(S, 'fact', ...
            sym(P(k)))));
        end
        for i = 1:numel(es);
            xid2 = sym(strcat(char(x), num2str(es{i}/2)));
            xi = sym(strcat(char(x), num2str(es{i})));
            w = w*((xid2*xi^((es{i}-2)/2))^P(es{i}));
        end;
        for i = 1:numel(os);
            xi = sym(strcat(char(x), num2str(os{i})));
            w = w*(xi^((os{i}-1)/2*P(os{i})));
        end
        for i = 1:floor(n/2)
            xi = sym(strcat(char(x), num2str(i)));
            w = w*(xi^(i*double(feval(S, 'binomial', P(i), ...
            2))));
        end
        for r=1:n-2
            for s=r+1:n-1
                if (P(r) > 0) & (P(s) > 0)
                   xi = sym(strcat(char(x), ...
                   num2str(lcm(r,s))));
                   w = w*(xi^(gcd(r,s)*P(r)*P(s)));
                   maxv = max([maxv, lcm(r,s)]);
                end
            end
        end
        cires = cires + w;
    end
    for i = 1:maxv
        xi = sym(strcat(char(x), num2str(i)));
        var{i} = xi;
    end
    cres{1} = cires;
    cres{2} = var;