function r = mixcolumn(M, f, x)
    L = [[x,1+x,1,1]; [1,x,1+x,1]; [1,1,x,1+x]; [1+x,1,1,x]];
    r = L*M;
    [m,n] = size(r);
    for i = 1:m
        for j = 1:n
            tr = feval(symengine, 'divide', r(i,j), ... 
            f, strcat('[', char(x), ']'));
            r(i,j) = mod(tr(2),2);
        end
    end
    r;