function p = partition(n)
  if n < 0
     p = strcat('Error: Input must be a non-negative integer but received', blanks(1), char(n));
  elseif n == 0 
     p = '[[]]';
  else
     pn = feval(symengine, 'combinat::partitions', n);
     part = firstpart(n);
     p = part;
     for i=2:pn
         part = nextpart(part);
         p = strcat(p, ',', char(1), part);
     end
     p = strcat('[', p, ']');
  end