function g = rscoeff(f, x, p, a)
    syms ng
    S = symengine;
    if feval(S, 'degree', f, x) > 0
       fs = sym2poly(2^(feval(S, 'degree', p)));
       for i = 1:fs-1
           field(i) = Powmod(a, i, p, a, 2);
       end;
       field(fs) = 0;
       g = feval(S, 'expand', f);
       ng = 0;
       dg = sym2poly(feval(S, 'degree', g, x));
       for j = 0:dg
           cg = feval(S, 'coeff', g, x, j);
           ncg = feval(S, 'numer', cg);
           dcg = feval(S, 'denom', cg);
           cg = ftable(Rem(ncg, p, a, 2), field) / ...
                ftable(Rem(dcg, p, a, 2), field);
           degdcg = sym2poly(feval(S, 'degree', dcg, a));
           if degdcg > 0
              cg = cg*a^(fs-1);
           end
           ng = ng + cg*x^j;
       end
       g = feval(S, 'expr', feval(S, 'poly', ng, ...
           'Dom::IntegerMod(2)'));
    else
       g = f;
    end
