function [St,iSt] = sboxtable(f,x)
    se = symengine;
    v = [1 0 0 0 1 1 1 1];
    S = [v];
    for i = 2:8
        v = circshift(v, [1,1]);
        S = [S ; v];
    end
    d = double(feval(se, 'degree', f, x));
    l = d/2;
    for i = 0:15
        rt = dec2bin(i);
        while length(rt) < l
              rt = strcat('0', rt);
        end
        for j = 0:15
            ct = dec2bin(j);
            while length(ct) < l
                  ct = strcat('0', ct);
            end
            pv = mod(double(strcat(rt,ct)), 2);
            ffe = poly2sym(pv);
            if ffe ~= sym(0)
               rm1 = ffe;
               r = f;
               um1 = 1;
               u = 0;
               dr = double(feval(se, 'degree', r, x));
               while dr >= 1
                     trp1 = feval(se, 'divide', rm1, r, ...
                            strcat('[', char(x), ']'));
                     rp1 = mod(trp1(2), 2);
                     q = mod(trp1(1), 2);
                     up1 = mod(um1 - u*q, 2);
                     um1 = u;
                     u = up1;
                     rm1 = r;
                     r = rp1;
                     dr = double(feval(se, 'degree', r, x));
               end
               y = sym2poly(u);
            else
               y = 0;
            end
            while numel(y) < d
                  y = [0 y];
            end
            y = fliplr(y);
            z = S * y' + [1 1 0 0 0 1 1 0]';
            St(i+1, j+1) = ...
            mod(poly2sym(fliplr(z')), 2);
            iz = mod(fliplr(z'), 2);
            ii = bin2dec(int2str(iz(1:l)));
            jj = bin2dec(int2str(iz(l+1:d)));
            iSt(ii+1, jj+1) = ffe;
        end
    end
    [St,iSt];