keysched := proc(key, St, f, x)
    local r, i, j, v, w, nk, nr, m, wmat;
    nk := LinearAlgebra:-ColumnDimension(key);
    nr := nk+6;
    wmat := key;
    for i from nk+1 to 4*(nr+1) do
        v := LinearAlgebra:-Column(wmat, i-nk);
        j := i-1;
        w := LinearAlgebra:-Column(wmat,j);
        if j mod nk = 0 then
           w := convert(w,list);
           w := convert(ListTools:-Rotate(w,1), 
           Vector[column]);
           w := LinearAlgebra:-Map(sbox, w, St, f, x);
           r := Rem(x^((j-nk)/nk), f, x) mod 2;
           w[1] := (w[1] + r) mod 2;
        fi:
        if nk > 6 and j mod nk = 4 then
           w := LinearAlgebra:-Map(sbox, w, St, f, x);
        fi:
        wmat := < wmat |LinearAlgebra:-Map(m -> sort(m) 
        mod 2, v+w) >;
    od:
    RETURN(wmat);
end:
