sboxtable := proc(f,x)
    local S, u, v, d, i, j, k, rt, ct, St, iSt, pv, ffe, y, 
    z, ii, jj, zv;
    v := [1, 0, 0, 0, 1, 1, 1, 1];
    S := < LinearAlgebra:-Transpose( < v > ) >;
    St := Matrix(16);
    iSt := Matrix(16);
    for i from 2 to 8 do
        v := ListTools[Rotate](v,-1);
        S := < <S>, LinearAlgebra:-Transpose( < v > ) >;
    od:
    d := degree(f,x);
    for i from 0 to 15 do
        rt := ListTools:-Reverse(convert(i, base, 2));
        while nops(rt) < d/2 do
              rt := [0,op(rt)];
        od:
        for j from 0 to 15 do
            ct := ListTools:-Reverse(convert(j, base, 2));
            while nops(ct) < d/2 do
                  ct := [0,op(ct)];
            od:
            pv := [op(rt),op(ct)];
            ffe := add(pv[degree(f)-k]*x^k, 
            k=0..degree(f)-1);
            if ffe <> 0 then
               Gcdex(ffe, f, x, 'u', 'v') mod 2;
            else
               u := 0;
            fi:
            y := [];
            for k from 0 to degree(f,x)-1 do
                y := [op(y), coeff(u, x, k)];
            od:
            y := convert(y, Vector[column]);
            zv := map(m -> m mod 2, S . y + <1, 1, 0, 0, 0, 
            1, 1, 0>);
            z := add(zv[k+1]*x^k, k=0..degree(f,x)-1) mod 2;
            St[i+1, j+1] := sort(z);
            ii := add(zv[d/2+k]*2^(k-1), k=1..d/2);
            jj := add(zv[k]*2^(k-1), k=1..d/2);
            iSt[ii+1, jj+1] := ffe;
        od:
    od:
    RETURN(St,iSt):
end:
