syms x
p = @(x) x^8 + x^4 + x^3 + x + 1;
Irreduc(p(x), 2)
[Sbx inSbx] = sboxtable(p(x),x);
sbox(x^7+x^3+1, Sbx, p(x), x)
sbox(x^7+x^5+x^2+x+1, inSbx, p(x), x)
message = 'RENDEZVOUS AT SIX';
message(findstr(message, ' ')) = []
ptext = mblocks(message,16)
ptext = topoly(ptext,x)
A = reshape(ptext, 4, 4)
key = 'RIJNDAEL AES KEY';
key(findstr(key, ' ')) = [];
key = mblocks(key,16)
K0 = reshape(topoly(key,x), 4, 4)
KS = keysched(K0, Sbx, p(x), x);
KS(:, 5:6)
KS(:, 7:8)
K1 = KS(:, 5:8);
A0 = addrkey(K0,A)
B1 = bytesub(A0, Sbx, p(x), x);
C1 = shiftrow(B1);
D1 = mixcolumn(C1, p(x), x);
A1 = addrkey(K1,D1);
IMCA1 = invmixcolumn(A1, p(x), x);
C1 = invaddrkey(IMCA1, K1, p(x), x);
B1 = bytesub(C1, inSbx, p(x), x);
A0 = invshiftrow(B1)
A = addrkey(K0,A0)
ptext = reshape(A, 1, numel(A))
ptext = frompoly(ptext,x)
ptext1 = 'TRANSFER THE MONEY';
ptext1(findstr(ptext1, ' ')) = [];
ptext1 = mblocks(ptext1,16)
key16 = 'AES KEYS ARE SECURE';
key16(findstr(key16, ' ')) = [];
key16 = mblocks(key16,16)
ctext1 = aesencipher(ptext1, key16, Sbx, p(x), x)
aesdecipher(ctext1, key16, Sbx, inSbx, p(x), x)
key24 = 'AES IS MORE SECURE THAN DES';
key24(findstr(key24, ' ')) = [];
key24 = mblocks(key24,24)
ctext1 = aesencipher(ptext1, key24, Sbx, p(x), x)
aesdecipher(ctext1, key24, Sbx, inSbx, p(x), x)
ptext2 = ['TRANSFER ONE MILLION DOLLARS FROM STOCKS' ...
'TO BONDS'];
ptext2(findstr(ptext2, ' ')) = [];
ptext2 = mblocks(ptext2,16)
ctext2 = [];
for i = 1:numel(ptext2)
    ctext2 = [ctext2; aesencipher(char(ptext2(i)), ...
    key16, Sbx, p(x), x)];
end
ctext2
ptext2 = [];
for i = 1:size(ctext2,1)
    ptext2 = [ptext2; aesdecipher(ctext2(i, 1:16), ...
    key16, Sbx, inSbx, p(x), x)];
end
ptext2
reshape(ptext2', 1, numel(ptext2))