function res = aesdecipher(ctext, key, St, iSt, p, x)
    for i = 1:numel(ctext)
        bn = dec2bin(ctext(i));
        for j = 1:length(bn)
            bn = mod(double(bn), 2);
            ml(i) = poly2sym(bn,x);
        end
    end
    Ai = reshape(ml, 4, 4);
    Keyin = reshape(topoly(key,x), 4, length(key)/4);
    KS = keysched(Keyin, St, p, x);
    nk = size(Keyin,2);
    nr = nk+6;
    Ki = KS(1:4, 4*nr+1:4*(nr+1));
    Ai = addrkey(Ai,Ki);
    for i = nr-1:-1:1
        Dm = bytesub(Ai, iSt, p, x);
        C = invshiftrow(Dm);
        B = invmixcolumn(C, p, x);
        Ki = KS(1:4, 4*i+1:4*(i+1));
        Ai = invaddrkey(B, Ki, p, x);
    end
    Ai = bytesub(Ai, iSt, p, x);
    Ai = invshiftrow(Ai);
    K0 = KS(1:4, 1:4);
    A = addrkey(Ai,K0);
    polyv = reshape(A, 1, numel(A));
    alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    res = '';
    for i = 1:numel(polyv)
        s = bin2dec(int2str(sym2poly(polyv(i))));
        let = alphabet(s+1);
        res = strcat(res,let);
    end
    res;