function cterm = cpinv(pinv, term)
   S = symengine;
   cterm = pinv;
   if feval(S, 'degree', term) ~= feval(S, 'degree', pinv)
      cterm = 0;
   else
      st = sym(strsplit(char(term), '*'));
      for i=1:numel(st)
          v = sym(char(feval(S, 'indets', st(i))));
          d = feval(S, 'degree', st(i));
          cterm = feval(S, 'coeff', cterm, v, d);
      end
   end
   
   
   