function ecurve = epoints(ec, x, ub, p)
    S = symengine;
    pct = 0;
    k = 0;
    p = sym(p);
    while k <= double(p-1) & (pct <= ub)
          z = mod(subs(ec, x, k), p);
          if z == 0
             pct = pct+1;
             ecurve{pct} = [k,z];
          end
          if feval(S, 'powermod', z, (p-1)/2, p) ...
          == sym(1)
             z = feval(S, 'powermod', z, ...
             (p+1)/4, p);
             ecurve{pct+1} = [k,z];
             ecurve{pct+2} = [k, mod(-z, p)];
             pct = pct+2;
          end
          k = k+1;
    end
    if pct > ub
       pct = ub;
    end
    ecurve = ecurve(1:pct);