function r = invmixcolumn(M, f, x)
    iL = [[x+x^2+x^3, 1+x+x^3, 1+x^2+x^3, 1+x^3]; [1+x^3, ...
    x+x^2+x^3, 1+x+x^3, 1+x^2+x^3]; [1+x^2+x^3, 1+x^3, ...
    x+x^2+x^3, 1+x+x^3]; [1+x+x^3, 1+x^2+x^3, 1+x^3, ...
    x+x^2+x^3]];
    r = iL*M;
    [m,n] = size(r);
    for i = 1:m
        for j = 1:n
            tr = feval(symengine, 'divide', r(i,j), ... 
            f, strcat('[', char(x), ']'));
            r(i,j) = mod(tr(2),2);
        end
    end
    r;