function wmat = keysched(key, St, f, x)
    nk = length(key);
    nr = nk+6;
    wmat = key;
    for i = nk+1:4*(nr+1)
        v = wmat(:, i-nk);
        j = i-1;
        w = wmat(:,j);
        if mod(j,nk) == 0
           w = circshift(w, [-1,1]);
           for k = 1:numel(w)
               w(k) = sbox(w(k), St, f, x);
           end
           tr = feval(symengine, 'divide', x^((j-nk)/nk), ... 
                f, strcat('[', char(x), ']'));
           r = mod(tr(2), 2);             
           w(1) = mod(w(1)+r, 2);
        end
        if nk > 6 & mod(j, nk) == 4
           for k = 1:numel(w)
               w(k) = sbox(w(k), St, f, x);
           end
        end
        a = v + w;
        for k = 1:numel(a)
            a(k) = mod(a(k), 2);
        end
        wmat = [wmat,a];
    end
    wmat;