function f = midinotes(fn, inotes, instr, b12)
   n = inotes;
   nnum = numel(n);
   o = [60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71];
   if b12 == 1
      while mod(nnum, 12) ~= 0
          n = [n, 0];
          nnum = numel(n);
      end 
      notes = [];
      for j = 1:nnum/12
          nn = [];
          for i = (j-1)*12+1:j*12
              nn = [nn, 0, 144, o(n(i)+1), 96, ...
              129, 110, 144, o(n(i)+1), 0];
          end
          notes = [notes, nn,  127, 144, o(1),0];
      end
      num = 2^32 + numel(notes) + 7;
      b = [];
      while num > 0
          s = mod(num, 256);
          num = floor(num/256);
          b = [s, b];
      end
      b = b(2:5);
      m = [77, 84, 104, 100, 0, 0, 0, 6, 0, 0, 0, 1, 0, ...
           128, 77, 84, 114, 107, b, 0, 192, instr, notes, ...
           0, 255, 47, 0];
   else
      num = 2^32 + 9*nnum + 7;
      b = [];
      while num > 0
          s = mod(num, 256);
          num = floor(num/256);
          b = [s, b];
      end
      b = b(2:5);
      notes = [];
      for i = 1:nnum
          notes = [notes, [0, 144, o(n(i)+1), 96, ...
          129, 110, 144, o(n(i)+1), 0]];
      end
      m = [77, 84, 104, 100, 0, 0, 0, 6, 0, 0, 0, 1, 0, ...
            128, 77, 84, 114, 107, b, 0, 192, instr, notes, ...
            0, 255, 47, 0];          
   end
   fname = fopen(fn, 'w');
   fwrite(fname, m);
   fclose(fname);
   f = numel(m);