function x = mlog(b, a, m)
   S = symengine;
   N = floor(sqrt(m)) + 1;
   Ap(1) = 1;
   for j = 2:N
      Ap(j) = mod(Ap(j-1)*a, m);
   end
   f = 0;
   ani = feval(S, 'powermod', a, N, m);
   ani = mod(ani^(-1), m);
   k = 0;
   r = mod(b, m);
   while (f < 1) & (k < N)
      n = find(Ap == r);
      if numel(n) > 0
         f = 1;
      else
         k = k + 1;
         r = mod(r*ani, m);
      end
   end
   if numel(n) > 0 
      x = (n(1)-1) + N*k;
   else
      x = 'FAIL';
   end
   x;



