function e = rseuclid(t, f, g, z, p, a)
    S = symengine;
    rm1 = Expand(f, 2);
    r = Expand(g, 2);
    um1 = 1;
    u = 0;
    vm1 = 0;
    v = 1;
    dr = sym2poly(feval(S, 'degree', r, z));
    fs = sym2poly(2^(feval(S, 'degree', p)));
    mf = a^(fs-1);
    disp(' ');
    while dr >= t
          trp1 = feval(S, 'divide', rm1, r, strcat('[', char(z), ']'));
          rp1 = rscoeff(feval(S, 'expand', mf*trp1(2)), z, p, a);
          q = rscoeff(feval(S, 'expand', mf*trp1(1)), z, p, a); 
          vp1 = feval(S, 'expand', vm1-v*q);
          vm1 = v;
          v = vp1;
          v = rscoeff(v, z, p, a);
          up1 = feval(S, 'expand', um1-u*q);
          um1 = u;
          u = up1;
          u = rscoeff(u, z, p, a);
          rm1 = r;
          r = rp1;
          disp(['Q:', blanks(1), sortpoly(q, z), '   R: ', ...
                blanks(1), sortpoly(r, z),'   V: ', ...
               blanks(1), sortpoly(v, z), '   U: ', ...
               blanks(1), sortpoly(u, z)])
          dr = sym2poly(feval(S, 'degree', r, z));
    end
    fprintf('\n')
    e = [q, r, v, u];