function z = sbox(ffe, St, f, x)
    v = sym2poly(ffe);
    d = double(feval(symengine, 'degree', f, x));
    while numel(v) < d
          v = [0 v];
    end
    r = bin2dec(int2str(v(1:d/2)));
    c = bin2dec(int2str(v(d/2+1:d)));
    z = St(r+1, c+1);