aesdecipher := proc(ctext, key, St, iSt, p, x)
    local i, A, Ai, Keyin, K0, Ki, KS, B, C, Dm, nr, nk,
    cpb10, ml, res, alphabet;
    ml := [seq(add(convert(ctext[i],base,2)[j]*x^(j-1),
    j=1..nops(convert(ctext[i],base,2))), i=1..nops(ctext))];
    Ai := Matrix(4, 4, (i,j) -> ml[(j-1)*4 + i]);
    nk := length(key)/4;
    nr := nk+6;
    Keyin := Matrix(4, nk, (i,j) -> topoly(key,x)[(j-1)*4 + 
    i]);
    KS := keysched(Keyin, St, p, x);
    Ki := Matrix([LinearAlgebra:-Column(KS, 
    4*nr+1..4*(nr+1))]);
    Ai := addrkey(Ai,Ki);
    for i from nr-1 to 1 by -1 do
        Dm := bytesub(Ai, iSt, p, x);
        C := invshiftrow(Dm);
        B := invmixcolumn(C, p, x);
        Ki := Matrix([LinearAlgebra:-Column(KS, 
        4*i+1..4*(i+1))]);
        Ai := invaddrkey(B, Ki, p, x);
    od:
    Ai := bytesub(Ai, iSt, p, x);
    Ai := invshiftrow(Ai);
    K0 := Matrix([LinearAlgebra:-Column(KS, 1..4)]);
    A := addrkey(Ai,K0);
    cpb10 := (p,x) -> if p <> 0 then
        add(coeff(p, x, i)*2^i, i=0..degree(p)) 
        else 0 fi;
    res := convert(convert(map(cpb10, 
    LinearAlgebra:-Transpose(A), x), Vector[row]), list);
    alphabet := "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    RETURN(cat(seq(alphabet[res[i]+1], i=1..nops(res))));
end:
