aesencipher := proc(message, key, St, p, x)
    local i, A, Keyin, KS, K0, Ai, Ki, B, C, Dm, nk, nr, res,
    cpb10;
    A := Matrix(4, 4, (i,j) -> topoly(message, x)[(j-1)*4 + 
    i]);
    nk := length(key)/4;
    nr := nk+6;
    Keyin := Matrix(4, nk, (i,j) -> topoly(key,x)[(j-1)*4 + 
    i]);
    KS := keysched(Keyin, St, p, x);
    K0 := Matrix([LinearAlgebra:-Column(KS, 1..4)]);
    Ai := addrkey(A,K0);
    for i from 1 to nr-1 do
        B := bytesub(Ai, St, p, x);
        C := shiftrow(B);
        Dm := mixcolumn(C, p, x);
        Ki := Matrix([LinearAlgebra:-Column(KS, 
        4*i+1..4*(i+1))]);
        Ai := addrkey(Dm,Ki);
    od:
    B := bytesub(Ai, St, p, x);
    C := shiftrow(B);
    Ki := Matrix([LinearAlgebra:-Column(KS, 
    4*nr+1..4*(nr+1))]);
    Ai := addrkey(C,Ki);
    cpb10 := (p,x) -> if p <> 0 then
        add(coeff(p, x, i)*2^i, i=0..degree(p))
        else 0 fi;
    res := convert(LinearAlgebra:-Map(cpb10, Ai, x), 
    Vector[column]);
    RETURN(convert(res,list));
end:
