frompoly := proc(polyv,x)
    local alphabet, cpb10, p, res;
    alphabet := "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    cpb10 := (p,x) -> if p <> 0 then 
        add(coeff(p, x, i)*2^i, i=0..degree(p)) 
        else 0 fi;
    res := convert(LinearAlgebra:-Map(cpb10, polyv, x), 
    list);
    RETURN(cat(seq(alphabet[res[i]+1], i=1..nops(res))));
end:
