cperm := proc(p)
    local lp, i, rl, tmp, stmp, j;
    lp := StringTools:-DeleteSpace(convert(p, string)):
    rl := [];
    tmp := []; 
    i := 1;
    while lp[i] <> "" do 
        if lp[i] = "(" or lp[i] = "," then
           j := i+1;
           stmp := "";
           while lp[j] <> "," and lp[j] <> ")" do
              stmp := cat(stmp, lp[j]); 
              j := j + 1;
           od:
           tmp := [op(tmp), parse(stmp)]: 
        fi:
        i := j;
        if lp[i] = ")" then
           rl := [op(rl), tmp]: 
           tmp := []: 
           i := i + 1;
        fi:
    od:
    rl;
end:

fperm := proc(p, a)
    local i, tp, j, fd, k;
    fd := 0; 
    k := a;
    for i from 1 to nops(p) do
        tp := p[i];
        for j from 1 to nops(tp) - 1 do
            if k = tp[j] then
               k := tp[j+1];
               fd := 1;
               break;
            fi:
            if k = tp[nops(tp)] and fd <> 1 then
               k := tp[1];
               fd := 1;
            fi:
        od:
        if fd = 1 then
           break;
        fi:
    od:
    k;
end:

midichords := proc(fn, instr, poly, d)
   local group, i, j, k, s, res, nct, ct, eqnotes, notes, ntable, o, track, m;
   if add([coeffs(poly)][i], i = 1..nops([coeffs(poly)])) = 352 then
      group := convert(GroupTheory:-Elements(GroupTheory:-CyclicGroup(12)), list);
   else 
      group := convert(GroupTheory:-Elements(GroupTheory:-DihedralGroup(12)), list);
   fi:
   s := [];
   for i from 1 to nops(group) do
       s := [op(s), cperm(group[i])] 
   od:
   notes := combinat:-choose(12,d);
   ntable := table():
   for i from 1 to nops(notes) do
       ntable[ notes[i] ] := i:
   od:
   nct := coeff(poly, b, d);
   ct := 0;
   eqnotes := [];
   for j from 1 to nops(notes) do
       res := [];
       for i from 1 to nops(s) do
           res := sort(ListTools:-MakeUnique([op(res), 
                  ntable[sort( [seq(fperm(s[i], notes[j][k]), 
                  k = 1..nops(notes[j]))] )]])): 
       od: 
       if j = res[1] then 
          ct := ct + 1: 
          eqnotes := [op(eqnotes), notes[j] - [seq(1, k = 1..nops(notes[j]))]]; 
       fi:
       if ct = nct then
          break;
       end:
    od:
    o := Array(0..11, [60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71]);
    track := [];
    for j from 1 to d do
        track := [op(track), 77, 84, 114, 107, op(ListTools:-Reverse(convert(2^32 + 9*(nct) + 7, base, 256))[2..-1]), 
                    0, 192, instr, seq( op([0, 144, o[eqnotes[i][j]], 96, 130, 30, 144, o[eqnotes[i][j]], 0]), i = 1..nct),
                    0, 255, 47, 0];
    od: 
    m := [77, 84, 104, 100, 0, 0, 0, 6, 0, 1, 0, d, 0, 128, op(track)];
    writebytes(fn, m);
    close(fn);
    eqnotes;
end:
